static char *cvs_id =" $Id: xnd_amo.c,v 1.4 2004/07/30 08:04:10 berar Exp $ ";
/* XND_AMO    amorphous phases ... a lot of dummy things */

#define  USE_BRAGG
#define  USE_VAR
#define  USE_SCAN
#define  USE_EXPER
#define  USE_ATOM
#define  USE_PENAL
#define  USE_PHASE
#include "../xnd_def.h"
#include "../xnd_cah.h"
#include "../xnd_mem.h"

/* #define DEBUG   1 */
#define USE_IQ0 1
/* ---------------------------------------------------------- */
/* ---------------------------------------------------------- */
void int_rdfpeak (P_(void))
{
   int    ip, n_dist, n_steps, ir;              /**********************/
   float  rlim, rstep, fsum, ycal, rho0, rmin, rdf;
   float *a_coef, *rdf_data, *drdf, *drdf_damp, *drdf_dsig, *drdf_dpos;

   FILE *fiq, *frdf;

   push_err_msg("int_rdfpeak(xnd_amo.c)");
   if (minli==0)
   {  fiq=fopen("xnd_iq.dat","w");
      fprintf (fiq, "#   q   i(q) = i_rdf + i_rlim\n");
      frdf=fopen("xnd_frdf.dat","w");             /**********************/
      fprintf (frdf, "#   \n");
      fprintf(list_fich,"\n");
      }
   n_dist = l_phase->nb_dist;
   rstep = l_phase->bond[0];
   rlim  = l_phase->bond[1];
   rmin  = l_phase->bond[2];
   n_steps=1+(rlim-rmin)/rstep;   /* nb pas pour integ  */
   rdf_data = (float *) tst_alloc(n_steps+1,sizeof(float),"rdf");
   if (do_derivatives)
   {   drdf_damp=drdf  = (float *) tst_alloc(3*(n_steps+1)*n_dist,sizeof(float),"rdf");
       drdf_dpos=drdf+ 1*(n_steps+1)*n_dist;
       drdf_dsig=drdf+ 2*(n_steps+1)*n_dist;
       memset(drdf,0,3*(n_steps+1)*n_dist);
       }

   rho0=0;
   for (ir=0;ir<=n_steps;ir++)
   {  int ng, ig;
      float rdf = 0;
      float r = rmin + ir * rstep;
      rdf=0;
  	  var_init(l_phase->radial);
      for (ig=ng=0; ng<n_dist; ng++, ig+=3)
      {  float amp, rr, sig, ex;
         amp=var_valeur(ig);
         rr = (r-var_valeur (ig+1))/(sig=var_valeur (ig+2));
         ex = exp (- 0.5*rr*rr);
         if (do_derivatives) 
         {  drdf_damp[ir+ng*n_steps]=ex;
            drdf_dpos[ir+ng*n_steps]=2* amp * ex * rr / sig;
            drdf_dsig[ir+ng*n_steps]=2* amp * ex * rr / sig /sig;
            }
         rdf+=amp*ex;
         } /* calculation of rdf(r) */
      rdf_data[ir]=rdf;
      rho0+=rdf*rstep;
      }    /* integration of rdf(r).dr using rstep */
   if (minli==0)
   {  rdf=rho0;
      rho0*=3/(4*M_PI*(rlim*rlim*rlim-rmin*rmin*rmin));
      verbose_printf (" N=%.2f e- between %.2f(RLIM) and %.2f(RMIN) => <rho>=%.3f\n", rdf, rlim, rmin, rho0);
      }
#ifdef DEBUG
   if ( cycle==0 )
   {  char buffer[100], fname[100];
      FILE *frdftest;
      int n;
      float xrdf;
      fname[0]=0;
      printf("\n RDF read from filename or gauss calc if empty ? ");
      fgets(buffer,100,stdin);
      sscanf(buffer, "%s", fname);
      if (strlen(fname)>=1)
      {   frdftest=tst_open(fname,"r","debug rdf data file");
          for (n=0;n<n_steps;n++) 
	       {  rdf_data[n]=0;
 		       fscanf(frdftest,"%f %f\n",&xrdf,&rdf_data[n]);
		       }
	       fclose(frdftest);
           printf("\%d RDF points have been read from '%s' file\n", n_steps, fname);
	       }
       }   
#endif
   /* rho0 is stored in place of overall B*/
   temp = &temp_phase;
   var_init (l_phase->ech);
   rho0  =  var_valeur (1);
   if (do_derivatives) a_coef= (float *) tst_alloc(3*n_dist,sizeof(float),"deriv");
   for (act->lambda=0;act->lambda<l_exper->n_lambda;act->lambda++)
   {  int n_pts, n;
      temp = &temp_exper;
      var_init (l_onde);
      lambda = var_valeur (act->lambda*LAMBDA);
      exper_echelle = var_valeur (act->lambda*LAMBDA+1);
      temp = &temp_phase;
      echelle = phase_echelle * exper_echelle;
      fprintf(list_fich , " echelle %f = phase_echelle %f  * exper_echelle %f\n",echelle, phase_echelle, exper_echelle);
      n_pts=l_diag->n_points;

      for (ip=0,l_points=l_diag->points;ip<n_pts;ip++,l_points++)
      {  int ia, n;
         float qq, qr, ampli, ycal, iq, iq0, fr, fi, f2r;
         float qra, qri,escale;
         sin_t = sin (0.5*RAD* *l_points);   /* valcor */
         qq = 2 * M_PI * (s = 2 * sin_t / lambda);
         q = s*s;                            /* valdif :  s and q*/
         cos_t = sqrt (1-sin_t*sin_t);
         valcor ();
         f2r = fr = fi = 0;
         escale=M_PI * echelle * act->cor;  /* M_PI for relative scale with uncoherent */
         for (ia=0,l_atom=l_phase->atom;ia<l_phase->n_atom;ia++,l_atom++)
         {  float occ, f;
            int nb = l_atom->nb;
            var_init(l_atom->x);
            occ = var_valeur (0);
            f = (*valdif)();
            if (dif_nature == EXPER_RXA)
            {   float a;
                f+=anodif();
                fr += occ *f;
                fi += occ * (a=anodif_b());
                f2r += (f*f + a*a)*occ;
                }
            else
            {  fr += occ *f;
               f2r += f*f*occ;
               }
            }
         fr = fr*fr + fi*fi;

         if (do_derivatives) memset (a_coef,0,3*n_dist*sizeof(FLOAT));
	     iq=0.;
	     for (n=1;n<=n_steps;n++)
	     {  int ng,ig;
            float sqr, rdf =0;
            float r = rmin + n * rstep;
            qr = qq * r;
	        if ( qq > EPSILON) sqr=sin(qr)/qr; else sqr = 0;
            iq += (rdf_data[n] - 4. * M_PI * r * r * rho0 ) * sqr * rstep ;
            if (do_derivatives) for (ng=ig=0; ng<n_dist; ng++, ig+=3)
            {  float c = escale * fr * sqr * rstep;
			   a_coef[ig]  += c  * drdf_damp[n+ng*n_steps];
		       a_coef[ig+1]+= c * drdf_dpos[n+ng*n_steps];
		       a_coef[ig+2]+= c * drdf_dsig[n+ng*n_steps];
               }
	         }    /* integration of rdf sinqr/sr dr using rstep*/

		 /* M_PI is mandatory for relative scale with uncoherent */
         ycal= escale * ( f2r + fr * iq  );
#ifdef USE_IQ0
	     qra = qq*rlim;
	     if ( qq > EPSILON) qra= (-qq*cos(qra)+sin(qra))/(qq*qq*qq);
         qri = qq*rmin;
	     if ( qq > EPSILON) qri= (-qq*cos(qri)+sin(qri))/(qq*qq*qq);
         iq0 = 4 * M_PI * rho0 * (qra - qri);
         ycal += escale *  iq0;
#ifdef DEBUG
         if (minli==0 && ip%20==0 && ip<50)
         {   printf ("ip %3d q %5.2f ycal  %6.0f ~ %6.2f=%6.2f+%6.2f*(%.3f=iq + %.3f=iq0)\n",
                  ip, qq, ycal, f2r + fr * (iq + iq0), f2r ,fr, iq, iq0);
             }
#endif
#else
#ifdef DEBUG
         if (minli==0 && ip%20==0 && ip<50)
         {   printf ("ip %3d q %5.2f ycal  %6.0f ~ %6.2f=%6.2f+%6.2f*%.3f=iq ) USE_IQ0 0 or undef\n",
                  ip, qq, ycal, f2r + fr * iq , f2r ,fr, iq);
             }
#endif
#endif

    	add_ical(ip, ycal);

      if (do_derivatives)
		{  int i, j;
         if (var_ideriv(l_onde))
			{ 	temp = &temp_exper;
		      VAR_io_id
		      i=act->lambda*LAMBDA+1;
		      if ((j=var_param(i))!=0)
		      add_dydp(ip, j, ycal / exper_echelle * var_derive());
		      temp = &temp_phase;
				}
         if (var_ideriv(l_phase->ech))
         {   VAR_io_id   for (i=0;i<var_number;i++)
             if ((j=var_param(0))!=0)
             if (i%2==0)  add_dydp (ip, j, ycal * *(d_echelle) * var_derive());
             else         add_dydp (ip, j, escale * fr * iq0 /rho0 * var_derive());
             }
         if (var_ideriv(l_phase->transit))
         {  VAR_io_id  for (i=0;i<var_number;i++)
            if ((j=var_param(i))!=0)
              add_dydp(ip, j,ycal * var_derive()* *(d_echelle+l_phase->ech->number+i));
            }
         if (var_ideriv(l_phase->radial))
         {  VAR_io_id  for (i=0;i<var_number;i++)
            if ((j=var_param(i))!=0)
              add_dydp(ip, j, var_derive()* a_coef[i]);
            }
         }
      else
      {  if ( l_phase->nb_angl && ip % l_phase->nb_angl == 0 )
#ifdef USE_IQ0
         fprintf (list_fich ,"RDF %4d %6.3f q %5.2f ycal = %6.2f ~ %6.2f+%6.2f*(%.3f=iq + %.3f=iq0)\n",ip, *l_points, qq, ycal, f2r ,fr, iq, iq0);
#else
         fprintf (list_fich ,"RDF %4d %6.3f q %5.2f ycal = %6.2f ~ %6.2f+%6.2f*%.3f=iq\n",ip, *l_points, qq, ycal, f2r ,fr, iq);
#endif
         if ( do_plg_data )  add_ipha(ip, act->phase, ycal);
         }
      }  /* ip loop */
   }  /* lambda */
   free(rdf_data);
   if (do_derivatives)
   {  free(drdf);
      free(a_coef);
      }   
   if (minli==0) fclose(fiq);
   pop_err_msg();
	}
/* ---------------------------------------------------------- */
/* ---------------------------------------------------------- */
void int_dist_lambda(P_(void));
TYPE_RADIAL *l_radial;
/* ---------------------------------------------------------- */
void int_amorphe (P_(void))
{
	int   n;
	int   nd;

	if (minli==0) fprintf(list_fich,"\n");
        nd = l_phase->nb_dist;
	for (act->lambda=0;act->lambda<l_exper->n_lambda;act->lambda++)
	{  temp = &temp_exper;
	   var_init (l_onde);
		lambda = var_valeur (act->lambda*LAMBDA);
		exper_echelle = var_valeur (act->lambda*LAMBDA+1);
		echelle = phase_echelle * exper_echelle;
      temp = &temp_phase;
		for (n=0, l_radial = l_phase->radial; n<nd; n++,l_radial++)
		    int_dist_lambda();
      }
	}

/* ---------------------------------------------------------- */
float angle ( P_(float) d)
#ifdef NO_PROTO
float d;
#endif
{   float a;
    a = 2/RAD * asin((double) (0.5*lambda/d));
    return a;
   }

/* ---------------------------------------------------------- */
static float ampli;
void amplitude (P_(float) dth)
#ifdef NO_PROTO
float dth;
#endif
{
     sin_t = sin (0.5*RAD*dth);   /* valcor */
     s = 2 * sin_t / lambda;
     cos_t = sqrt (1-sin_t*sin_t);
     valcor ();
     q = s * s;                   /* valdif */
     l_atom = l_radial->at0;
     F_A = valdif();
     l_atom = l_radial->at1;
     F_B = valdif();
     ampli = echelle * act->cor * F_A * F_B;
     }

 /* ---------------------------------------------------------- */
void int_dist_lambda()
{    int   nb_pos;
     float *pos;
     int   i,j,iod;
     int   ip,jp;
     float v1,v2;
     float v,hd,hh;
     float aa,na;
     float z,val;
     float *v1_deriv,*v2_deriv;
     int *p1_deriv,*p2_deriv;
     int   calc_deriv;

     nb_pos=l_radial->nb_pos;
	  fprintf(list_fich," int_dist_lambda    npos %d\n", nb_pos);
     if (nb_pos==0) return;

     temp = &temp_phase;
     var_init(l_radial->distrib);

     for (ip=0,l_points=l_diag->points;ip<n_pts;ip++,l_points++)
     {   
/*         if ( ip % 50 == 0 ) fprintf(list_fich , "amo0 %d  aa %f na %f\n",
             ip, aa, na);     
/*         if ( *l_points <= aa ) continue;   /* pas d'extrapolation */
			amplitude(*l_points);
	      add_ical (ip, ampli);
     if ( ip % 50 == 0 ) fprintf(list_fich , " amo %d  %f  %f\n",
        ip, *l_points, ampli);     
	    }
    }
 /* ---------------------------------------------------------- */
/*
void old_int_dist_lambda()
{    int   nb_pos;
     float *pos;
     int   i,j,iod;
     int   ip,jp;
     float v1,v2;
     float v,hd,hh;
     float aa,na;
     float z,val;
     float *v1_deriv,*v2_deriv;
     int *p1_deriv,*p2_deriv;
     int   calc_deriv;

     nb_pos=l_radial->nb_pos;
	 fprintf(list_fich," int_dist_lambda    npos %d\n", nb_pos);
     if (nb_pos==0) return;

     pos = l_radial->diff_pos;
     temp = &temp_phase;
     if (fini==0 && minli==0)
     {    v1_deriv = (float *) tst_alloc (var_order,sizeof(float),"distrib");
	  v2_deriv = (float *) tst_alloc (var_order,sizeof(float),"distrib");
	  p1_deriv = (int *) tst_alloc (var_order,sizeof(int),"distrib");
	  p2_deriv = (int *) tst_alloc (var_order,sizeof(int),"distrib");
	  calc_deriv = 1;
	  }
	  else calc_deriv = 0;
     jp=1;
     var_init(l_radial->distrib);
     v1 = var_valeur (0);
     v2 = var_valeur (1);
     if (calc_deriv!=0) VAR_io_id
     {   iod = var_io*var_dim+var_id;
         if ( (p1_deriv[iod] = var_param(0))!=0 )
		  v1_deriv[iod] = var_derive ();
	 if ( (p2_deriv[iod] = var_param(1))!=0 )
		  v2_deriv[iod] = var_derive ();
	 }
     aa = angle (*pos);
     na = angle(*(pos+1));
     hh = na - aa;
     v = (v2-v1);
     for (ip=0,l_points=l_diag->points;ip<n_pts;ip++,l_points++)
     {   
         if ( ip % 50 == 0 ) fprintf(list_fich , "amo0 %d  aa %f na %f\n",
      ip, aa, na);     
         if ( *l_points <= aa ) continue;   /* pas d'extrapolation */
/*	 if ( jp > nb_pos)   break;
	 if ( *l_points >= na )
	 {   /* on prepare la table */
/*             v1 = v2;
	     pos++;
             aa = na;
	     var_init(l_radial->distrib);
	     if (calc_deriv!=0) VAR_io_id
	     {   VAR_iod;
	         p1_deriv[iod] = p2_deriv[iod];
		 v1_deriv[iod] = v2_deriv[iod];
		 }
	     if ( ++jp < nb_pos)
	     {   na = angle (*(pos+1));
		 v2 = var_valeur (jp);
		 if (calc_deriv!=0) VAR_io_id
		 {   VAR_iod;
		     if ((p2_deriv[iod] = var_param  (jp))!=0)
		      v2_deriv[iod] = var_derive ();
		      }
		 hh = na - aa;
		 v = (v2-v1);
		 }
	     ip--; l_points--;
	     }
	 else
	 {    ini_amplitude ( *l_points);
              hd = (*l_points - aa) / hh;
				  val = ampli * (v1 + v * hd);
	      add_ical (ip, val);
if ( ip % 50 == 0 ) fprintf(list_fich , " amo %d  %f = %f *( %f + %f * %f)\n",
      ip, val, ampli, v1, v, hd);     
	      if (calc_deriv!=0)
	      {   /* la distribution */
/*		  var_init(l_radial->distrib);
		  VAR_io_id
		  {   VAR_iod;
		      if (p1_deriv[iod])
			add_dydp(ampli * (1-hd) * v1_deriv[iod],ip,p1_deriv[iod]);
		      if (p2_deriv[iod])
			add_dydp(ampli * hd * v2_deriv[iod],ip,p2_deriv[iod]);
		      }
		  /* onde */
/*		 temp = &temp_exper;
		  var_init(l_onde);
		  VAR_io_id
		  for (i=act->lambda*LAMBDA;i<act->lambda*LAMBDA+LAMBDA;i++)
		  if ((j=var_param(i))!=0)
		  {  switch (i%LAMBDA)
		     {
		       case 1 : z = val / exper_echelle;               break;
			   };
		       add_dydp(z * var_derive(), ip,j);
		       }
		 temp = &temp_phase;
		 /* phase scale , overall B non utilise */
/*		 var_init(l_phase->ech);
		 VAR_io_id  for (i=0;i<1;i++)
		 if ((j=var_param(i))!=0)
		  add_dydp (val * var_derive() * *(d_echelle+i),ip,j);
		 /* phase transition scale */
/*		 var_init(l_phase->transit);
		 VAR_io_id  for (i=0;i<var_number;i++)
		 if ((j=var_param(i))!=0)
		       add_dydp(val * var_derive()* *(d_echelle+l_phase->ech->number+i), ip,j);
		 }
	    }
	}
     if (calc_deriv!=0)
     {   free (v1_deriv);
	 free (v2_deriv);
	 free (p1_deriv);
	 free (p2_deriv);
	 }
    }
 /* ---------------------------------------------------------- */
 /* ---------------------------------------------------------- */

