static char *cvs_id =" $Id: xnd_cal.c,v 1.3 2004/07/30 08:04:05 berar Exp $ ";
/* XND_CAL  Calcul Theta hkl ... */

#define  USE_RPRO
#define  USE_BRAGG
#define  USE_VAR
#define  USE_SCAN
#define  USE_EXPER
#define  USE_PENAL
#define  USE_PHASE
#define  USE_PSEUDO
#include "../xnd_def.h"
#include "../xnd_cah.h"
#include "../xnd_mem.h"

#ifndef _INCLUDE_HPUX_SOURCE
#include <time.h>
/* required for rand init */
#endif

#include <string.h>
/* ----------------------------------------------------------- */
/* ----------------------------------------------------------- */
static int search_first ( P_(FLOAT) valeur)
#ifdef NO_PROTO
float valeur;
#endif
{   int  act=0;
    int  sup=n_pts;
    int  inf=0;
    int  dif;
    FLOAT *l_pt;
    l_pt = l_points;
    while (sup!=inf)
    {    act += (dif = (sup+inf-1)/2 - act);
	 l_pt += dif;
	 if ( valeur >= *l_pt )
	     inf = act+1;
	 else sup = act;
	 }
    l_points = l_pt;
    return (sup);
    }

/* ----------------------------------------------------------- */
static int profil_hkl (P_(void))
{   float fin,debut;
    int   nombre=0;
    int   pos;

   fin = DTH + influence;
   if (fin>diag_pn) fin= diag_pn;
   debut = DTH - influence;
   if (debut<diag_p0) debut = diag_p0;
   l_points = l_diag->points;
   pos = first_point = search_first (DTH);
   if (first_point < n_pts)
   {  l_points = &l_diag->points[pos];
	   while ((pos<n_pts) && (profil_point (pos) || *l_points<=fin))
	   {  l_points++;
		   nombre++;
		   pos++;
         }
	   act->fin = (pos == n_pts) ? pos-1 : pos;
	   pos = first_point - 1;
      l_points = &l_diag->points[pos];
 	   while (( pos >= 0 )&& (profil_point (pos)|| *l_points>=debut))
	   {  l_points--;
		   nombre++;
		   pos--;
	      }
	  act->deb = (pos < 0) ? 0 : pos;
     }
  return(nombre);
  }
/* ----------------------------------------------------------- */
void traite_hkl(P_(void))
{  int vu = 2;
   push_err_msg("traite_hkl(xnd_cal.c)");
   n_bragg++;
   if (def_profil())
   {  if (ini_profil() != 0)
	   {  if (fini==0) ini_d_metric ();
	     vu = 1;
	     if (profil_hkl() != 0)
	     {   m_bragg++;
	         vu = 0;
		 if ( /* fini && */ bragg_fich != NULL)
		     fwrite (act, bragg_size, 1, bragg_fich);
		  }
	      } 
	 if (fini && prt_hkl & 6 && vu)  fprintf (list_fich,
             "   (%d)%3d%3d%3d (%d) %7.3f %6.1f (%6.1f %6.1f) %s\n",
	     act->phase,H,K,L,act->lambda,DTH,I_C,F_A,F_B,
	     vu==2?"negligeable":"non visible");
	 }
    else fprintf (list_fich,
 " --- (%d)%3d%3d%3d (%d) %6.3f %2d %7.2f %7.2f %6.0f (%5.1g %5.1g) %5.3f sqrt(%5.3f) non positive width\n",
	 act->phase,H,K,L,act->lambda,DTH,act->mu,act->cor,
	 act->orien,I_C,F_A,F_B,W_G,act->w_lorentz);
    pop_err_msg();
    }

/* ----------------------------------------------------------- */
/* calcul echelle : exp(a) / (exp(a)+exp(-a)) = 1/(1+exp(-2a)  */
/* avec  a = signe(t-to) * dt * abs(t-to)^t_ex                 */
/* deriv est divise par sa valeur cf son usage */
float f_echelle(P_(int) i, P_(float *) d)
#ifdef NO_PROTO
int i;
float *d;
#endif
{   int j; 	
	 float to,dt,ex,tex;
	float u,a,b,c,rt,et;
	float *deriv;

	j = i;
	deriv = d + l_phase->ech->dim + j;
	*deriv = *(deriv+1) = *(deriv+2) = 0;
	var_init(l_phase->transit);
	to = var_valeur (j);
	dt = var_valeur (1+j);
	ex = var_valeur (2+j);
        u = (l_diag->temp - to);
	if (u < 0 )  { a = -1;  u = -u; } else a=1;
        b = a * dt;
	if ( u > EPSILON )
	{   tex = -2 * b * ( c = pow(u,ex));
		if (tex < LN_MAXFLOAT)
		{   rt = ( 1 / ( 1 + (et = exp (tex))));
			et *=  2*rt;        /* rt^2/rt cf usage */
			*deriv =  -et * b * ex * c / u;
			*(deriv+1) = et * a * c;
			*(deriv+2) = et * b * c * log(u);
			return (rt);
			}
		return (0);
		}
	return (0.5);
	}
/* ----------------------------------------------------------- */
/* ----------------------------------------------------------- */

