static char *cvs_id =" $Id: xnd_ips.c,v 1.4 2004/07/30 08:04:18 berar Exp $ ";
/* XND_IPH.C                                  */
/* initialisation of phases for calculation   */

#define  USE_BRAGG
#define  USE_SETS
#define  USE_SYM
#define  USE_PHASE
#define  USE_PSEUDO
#include "../xnd_def.h"
#include "../xnd_cah.h"
#include "xnd_moh.h"

#include <string.h>
/*-------------------------------------------------*/
void ini_pseudo_sets PROTO((void));
/*-------------------------------------------------*/
void ini_pseudo_phase (P_(void))
{  int    i, isat, err = 0;
   int    iphase;
   char   bravais;
   char   txt[80];
   TYPE_PSEUDO * first_pseudo;
	TYPE_SETS * l_sets;
	
   push_err_msg("ini_pseudo_phase(xnd_ips.c)");

   prt_modsize = 0;
   pseudo_phase = (TYPE_PSEUDO *)tst_alloc (tot_phase ,sizeof(TYPE_PSEUDO),"pseudo_phase");
   l_pseudo_phase = pseudo_phase;
   for (iphase=0,l_phase=phase; iphase<n_phase; iphase++,l_phase++)
   {  push_err_msg(l_phase->nom);
      current_symgrp = l_phase->symgrp;
      first_pseudo = l_pseudo_phase;
		l_pseudo_phase->phase = l_phase;
      l_pseudo_phase->ps_case = PS_STD;
      l_pseudo_phase->reference = iphase;
      l_pseudo_phase->satel = NULL;
      l_pseudo_phase->modul = NULL;
      l_pseudo_phase->sets = l_sets = l_phase->sets;
      l_pseudo_phase->symgrp = current_symgrp;
      l_pseudo_phase->txt = "";
	   l_pseudo_phase->fhkl_eff = fhkl_atom;
	   l_pseudo_phase->cell_fhkl = cell_fsum;
	   l_pseudo_phase->hkl_eff    = hkl_std;
      if (l_phase->nature != PHASE_RADIAL && l_phase->nature != PHASE_RDFPEAK )
      {   if (l_phase->nb_sets>1) l_pseudo_phase->txt = "SET_0";
          l_pseudo_phase->genget_hkl =  
			    (l_sets->nb_hkl == PHASE_GENERE ) ? gen_hkl: get_hkl;
          if (current_symgrp)
          {  l_pseudo_phase->fhkl_mult = ini_3D_fhkl_mult(current_symgrp);
/* (void*) used to return function pointers are not assignment-compatible */
				 l_pseudo_phase->extinction   = ini_3D_extinction( current_symgrp);
             l_pseudo_phase->multiplicity = ini_3D_multiplicity(current_symgrp); 
             l_pseudo_phase->gen_holoedre = ini_3D_gen_holoedre(current_symgrp);
	    for (i = 1; i < l_phase->nb_sets ; i++)
	    {   l_pseudo_phase++;
           memcpy (l_pseudo_phase,l_pseudo_phase-1,sizeof(TYPE_PSEUDO));
           sprintf (txt, "SET_%d",i);
           l_pseudo_phase->txt = str_alloc(txt);
           l_pseudo_phase->sets = l_phase->sets + i;
           l_pseudo_phase->genget_hkl =  (l_pseudo_phase->sets->nb_hkl == PHASE_GENERE ) ?
                                           gen_hkl: get_hkl;
           l_pseudo_phase->ps_case = PS_STD;
		     }
              }  /* sym_grp */
           } /* != PHASE_AMORPHE */
        l_pseudo_phase++;
        pop_err_msg();
        } /* for iphase */
    if (tot_phase  )
    {   fprintf (list_fich,"\n");
        if (tot_phase != n_phase) fprintf (list_fich,
        " The number of phases has been adjusted internally to %d to take into account \
sets of lines associated with modulated structures...\n", tot_phase);
       for (iphase=0,l_pseudo_phase=pseudo_phase; iphase<tot_phase; iphase++,l_pseudo_phase++)
       {   int is_magnet;
           l_phase=l_pseudo_phase->phase;
           fprintf (list_fich,"\n Internal phase %d '%s' %s\n",
                 iphase, l_phase->nom, l_pseudo_phase->txt);
			  if (l_phase->magnet != NULL)
              err+= ini_pseudo_mag(l_pseudo_phase, &is_magnet);
              else is_magnet = 0;
           if (l_phase->modul  != NULL && is_magnet == 0 )
              err+=  ini_pseudo_inc(l_pseudo_phase);
              err+=sets_analyse(l_pseudo_phase->sets);
           if (l_phase->nb_sets>1 && l_phase->m_prof)
              fprintf (list_fich," associated with profile key 'PROF_%d'\n",
			     iphase);
             }
        }
    bragg_size = sizeof(TYPE_BRAGG) + prt_modsize * sizeof(short);
    /* some system required boundary alignement for float in qsort ... , to be sure */
    if (bragg_size % sizeof(float)) bragg_size = (bragg_size / sizeof(float) + 1 ) *sizeof(float);
    act= default_bragg = tst_alloc( 1, bragg_size, "Bragg structure");
    tst_abort((err!=0), "error in sets rule");
	 fflush (list_fich);
    pop_err_msg();
    }
/* ------------------------------------------------------------------ */


