/* $Id: xnd_prof.h,v 1.1 2004/07/30 08:04:29 berar Exp $ */
/* XND_PROF.H    common header for profile functions */

#include "../xnd_def.h"
#include "../xnd_cah.h"

/* ----------------------------------------------------------- */
#ifndef EXTERN_PROF
#define EXTERN_PROF extern
#endif
/* =========================================================== */
EXTERN_PROF float (*f_asym)(P_(void));      /* asym redirection */
EXTERN_PROF float prof_dt2;
EXTERN_PROF float as_deriv, as_coef, w_asym;
EXTERN_PROF float as_d[MAX_ASYM];
EXTERN_PROF float w_x;                       /* gauss or real value */
EXTERN_PROF float i_coef;
EXTERN_PROF float x_coef;
EXTERN_PROF float w_y;                        /* lorentz or imag value */
EXTERN_PROF float j_coef;
EXTERN_PROF float y_coef;
EXTERN_PROF float dwx_dx,dwx_dy;              /* voigt derivatives */
EXTERN_PROF float di_dg,dy_dg,dj_dg,dx_dg;    /* pseudo voigt deriv */
EXTERN_PROF float di_dl,dy_dl,dj_dl,dx_dl;
EXTERN_PROF int prof_case;
/* 0, 1 =gauss, 2 = lorentz, 3 = psvoigt, 4 =voigt, 11=og, 13=ops  */
/* =========================================================== */
/* prototypes */
/* ----------------------------------------------------------- */
/* XND_PRAS.C   asymetry profile functions */
float asym_adj   PROTO((void));
float asym_herm  PROTO((void));
float asym_power PROTO((void));
/* ----------------------------------------------------------- */
/* XND_PRGA.C     gauss profile function */
float gauss_profil PROTO((void));
float gauss_dprof_dt PROTO((void));
float gauss_dprof_dg PROTO((void));
int ini_gauss PROTO((void));
/* ----------------------------------------------------------- */
/* XND_PRLO.C    lorentz profile function */
float lorentz_profil PROTO((void));
float lorentz_dprof_dt PROTO((void));
float lorentz_dprof_dl PROTO((void));
int ini_lorentz PROTO((void));
/* ----------------------------------------------------------- */
/* XND_PRPS.C   pseudo-voigt profile function */
float psvoigt_profil PROTO((void));
float psvoigt_dprof_dt PROTO((void));
float psvoigt_dprof_dg PROTO((void));
float psvoigt_dprof_dl PROTO((void));
int ini_psvoigt PROTO((void));
/* ----------------------------------------------------------- */
/* XND_PRVO.C    voigt profile function */
float voigt_profil PROTO((void));
float voigt_dprof_dt PROTO((void));
float voigt_dprof_dg PROTO((void));
float voigt_dprof_dl PROTO((void));
int def_profil PROTO((void));
int ini_voigt PROTO((void));
/* ----------------------------------------------------------- */
/* XND_PRAC.C   asymetry convolution */
void  ini_asym_convol PROTO((void));
int   def_asym        PROTO((void));
EXTERN_PROF float (*profil_asym)  PROTO((void));
EXTERN_PROF void  (*d_pil_asym)   PROTO((void));
/* =========================================================== */

