static char *cvs_id =" $Id: xnd_prvo.c,v 1.1 2004/07/30 08:04:27 berar Exp $ ";
/* XND_PRVO.C    voigt profile function */

#define  USE_BRAGG
#include "xnd_prof.h"
/* =========================================================== */
/* VOIGT : utilise le calcul fonction d'erreur complexe
   w(z)=exp(-z^2)erfc(-iz) pour x,y >=0
   x = M_SQRT4LN2 d / wg et  y = = M_SQRTLN2 wl/ wg
   Voigt = M_SQRT4LN2 * M_1_SQRTPI / wg  * Re(w) ????
   Voigt = M_2_PI / wg  * Re(w) est en accord avec G, L et pseudo
   adapte de GAUTSCHI, SIAM J.Numer.Anal. 7 (1970) p187
   precision attendue 0.5E-10
   partie reelle w_x + imaginaire w_y necessaire pour la derivee :
   dw/dz = -2zw+2i/sqrt(PI)
   d(w_x)/dx = 2 ( y.w_y -  x.w_x)
   d(w_x)/dy ne  semble pas exprimable elle est donc calculee numeriquement
   */
/* ----------------------------------------------------------- */
#define XO   5.33
#define YO   4.29
#define HO   1.6
#define NO    6
#define NI   23
#define NUO   9
#define NUI  21
/* ----------------------------------------------------------- */
double voigt_valeur (P_(double) x, P_(double) y)
#ifdef NO_PROTO
double x;
double y;
#endif
{    double rx, ry, sx, sy, tx, ty, px, py;
    double dr, h, h2, h2n, s;
    int   nu, n1, n , m;

    if ( x >= XO || y >= YO)
    {   h = 0;
        n = 0;
        nu = 8;
        }
    else
    {   s = (1.0 - y / YO) * sqrt(1.0-(x/XO)*(x/XO));
        h2 = 2 * ( h = HO * s);
        n = NO + NI * s + 0.5;
        nu = NUO + NUI * s + 0.5;
        tx = h2n = pow (h2, (double) n);
        }
    rx = ry = tx = ty = 0;
    for (m=nu;m>=0;m--)
    {   n1 = m+1;
        dr = 2 * ((px=h+n1*rx+y) * px + (py=n1*ry-x) * py);
        rx = px / dr;
        ry = - py / dr;
        if ((h != 0) && (m <= n))
        {   sx = rx * tx - ry * ty;
            sy = ry * tx + rx * ty;
            ty = sy;
            tx = sx + (h2n /= h2);
            }
        }
    if (h != 0)  { w_y = sy;  return (sx); }
    else    { w_y = ry; return (rx); }
    }

/* ----------------------------------------------------------- */
#define D_EPSILON  1.0E-6
float voigt_profil (P_(void))
{   double x, y;
    double sx;

    x = fabs( dt / x_coef );
    y = y_coef;
    sx = voigt_valeur (x, y);
    if (fini==0 && minli==0)
    /* calcul des derivees, les valeurs obtenues sont divisees par x_coef */
    {    dwx_dx = i_coef * 2 * ( w_y * y - sx * x) / x_coef;
     if (dt < 0) dwx_dx = - dwx_dx;
     y += D_EPSILON;
     dwx_dy = i_coef * (voigt_valeur (x,y) - sx) / D_EPSILON/ x_coef;
     }
    w_x = i_coef * sx;
    return (w_x);
    }
/* ----------------------------------------------------------- */
float voigt_dprof_dt(P_(void))
{   return ( - dwx_dx );
    }
/* ----------------------------------------------------------- */
float voigt_dprof_dg (P_(void))
{   return ( -(dwx_dx * dt + dwx_dy * W_L / 2 + w_x) / (W_G*W_G));
    }
/* ----------------------------------------------------------- */
float voigt_dprof_dl (P_(void))
{   return ( dwx_dy / 2 ) ;
    }
/* ----------------------------------------------------------- */
int ini_voigt (P_(void))
{   x_coef = W_G / M_SQRT4LN2;
    y_coef = W_L / (2 * x_coef);
    i_coef = M_2_PI * I_C / x_coef;
    if (i_coef<0.5*minimum) return (0);
    influence = 2 * sqrt (x_coef*x_coef*( 1 + y_coef*y_coef) );
    if (i_coef < minimum ) influence *=0.5;
    prof_case =4;
    return (1);
    }
/* ----------------------------------------------------------- */
