static char *cvs_id =" $Id: xnd_rex1.c,v 1.2 2004/07/30 08:04:35 berar Exp $ ";
/* XND_REX1.C   read the experimental data (1 dim files) */

#define USE_KEYS
#define USE_SCAN
#define USE_EXPER
#define USE_OBS
#include "../xnd_def.h"
#include "xnd_rdh.h"
#include "../xnd_mem.h"

#define EPS_CHK 0.01

/* ------------------------------------------------------------------ */
/* ------------------------------------------------------------------ */
static step_fich (P_(FILE *)fich, P_(int) ligne, P_(int) compteur)
#ifdef NO_PROTO
FILE *fich;
int ligne;
int compteur;
#endif
{    int    i,j,lig;
     int    bloc,blk;
     int    nb,total=0;
     float  dtheta,pas,dthetaf,smono;
     TYPE_OBS    obs;
     float  dt,dtx,dt0,dtf,val;
     float  sdiv,scale,smono0,scale0,wscale,wscale0;
     int    moniteur,iscale;
     char   buffer[100], *res;

     push_err_msg("step_fich(xnd_rex1.c)");
	  lig = ligne-1;
     do tst_abort((fgets (buffer,100,fich) == NULL),
              E_ZEROP, l_diag->fich_name);
        while (buffer[0]=='#');
     switch (sscanf (buffer,"%d %f %f",&bloc,&scale0,&wscale0))
     {    case 1 : scale0 = 1;
          case 2 : wscale0 = 1;
          }
     if (scale0 < EPSILON) scale0= 1;
     if (wscale0 < EPSILON) wscale0= 1;
     dtx = MINFLOAT;
     for (blk=0; blk<bloc; blk++)
     {    buffer[0]= 0;
          while (((res =fgets (buffer,100,fich)) == NULL) || (strlen(buffer) < 3) ) 
                tst_abort( (res == NULL), "Bloc #%d / %d non trouve", blk, bloc);
  	  switch (sscanf (buffer,"%f%f%f%f%f%f",&dtheta,&pas,&dthetaf,&smono,&dt0,&dtf))
	  {   case 0 : case 1 :
	      case 2 : pas = -1;
	      case 3 : smono = 0;
	      case 4 : dt0 = dtheta;
	      case 5 : dtf = dthetaf;
	      }
          if (bloc > 1) fprintf(list_fich,
             " bloc #%d : dt0 %.3f ddt %.3f dtf %.3f sm %.0f dt0 %.3f dtf %.3f\n",
             blk, dtheta, pas, dthetaf, smono, dt0, dtf);
	  tst_abort( (dtheta<=0 || pas<= 0 || dthetaf <= dtheta), " parametre en lecture bloc #%d /%d", blk, bloc);;
	  tst_abort ( (dtheta<= dtx) ,E_NEGAT, dtx, dtheta);
	  iscale =  ! (smono==0 || blk==0 );
	  if (blk==0) smono0=smono;
	  if (iscale) scale = scale0 * fabs( smono / smono0);
	  else scale = scale0;
	  wscale = wscale0 * scale/scale0;
	  moniteur = smono > 0;
	  nb = 1+(dtf + EPSILON - dt0)/pas;
	  for (i=0; i<nb; i++)
	  {   dt = i * pas + dt0;
              j=fscanf(fich,"%f",&val);
	      tst_abort((j==0),E_READ,"i_obs",dt);
	      tst_abort ((dt>=180),E_READ,"dtheta",dt);
	      if (compteur) fscanf (fich,"%f",&sdiv);
	      if (dt >= dtheta && dt <= dthetaf)
	      {   total++;
		  obs.dtheta=dtx=dt;
		  obs.i_obs = val;
		  obs.weight = (obs.i_obs>0) ? 1/obs.i_obs : 0;
		  if (total==1) l_diag->dtheta0 = obs.dtheta;
		  if (compteur>0) obs.weight *= sdiv;
		  obs.i_obs *= scale;
        if (obs.i_obs > l_diag->y_max ) l_diag->y_max = obs.i_obs;
		  obs.weight *= scale * wscale;
		  if (moniteur)   obs.weight += 1/smono;
		  obs.weight *= l_exper->weight;
		  data_write (&obs);
		  if (obs.weight>0 && obs.weight>l_diag->w_mini)
		      l_diag->w_mini = obs.weight;
		  }
	      else if (dt + pas > dthetaf && blk == bloc-1) break; 
	      if (i%ligne == lig) fscanf(fich,"%*[^\n]%*[\n]");
	      }
	  if (i%ligne != lig) fscanf(fich,"%*[^\n]%*[\n]");
	  }
     l_diag->dthetaf = dtx;
	  tst_abort((total==0),E_ZEROP,l_diag->fich_name);
     pop_err_msg();
     return (total);
     }

/* ------------------------------------------------------------------ */
static int tab_fich (P_(FILE *)fich, P_(int) i1, P_(int) i2, P_(int) i3, P_(int) iw)
#ifdef NO_PROTO
FILE *fich;
int i1, i2, i3, iw;
#endif
{    int    i, n;
     int    total=0;
     TYPE_OBS    obs;
     float  w, s, dth;
     float  dt = MINFLOAT;
     char  buffer[250];
     char  format[100];

     push_err_msg("tab_fich(xnd_rex1.c)");
     do
     {   tst_abort((fgets (buffer,249,fich) == NULL),
              E_ZEROP, l_diag->fich_name);
         if ( feof(fich) )  continue;
         if ( buffer[0]=='#' ) verbose_printf("%s", buffer);
         } while (buffer[0]=='#' || buffer[0] =='\n' || buffer[0] =='\r');
      format[0]=0;
      for(i=0;i<i1;i++) strcat(format,"%*f");
      strcat(format,"%f");
      for(i=0;i<i2;i++) strcat(format,"%*f");
      strcat(format,"%f");
      if(iw) 
      {   for(i=0;i<i3;i++) strcat(format,"%*f");
          strcat(format,"%f");
	  }
   while (!feof(fich) )
   {  if ( fgets (buffer,249,fich) == NULL) continue;
      n = sscanf(buffer,format, &dth, &s, &w);
      if ( n < 2 || (iw && n !=3)) break;
      tst_abort ( (dth<= dt) ,E_NEGAT, dt, dth);
      if (dth>=998.0) break;
      tst_abort ( (dth>=180 || dth<0) ,E_RANGE, i, dth);
      obs.dtheta = dt = dth;
      obs.i_obs = s;
      if (obs.i_obs > l_diag->y_max ) l_diag->y_max = obs.i_obs;
      if (iw) obs.weight = w>0 ? 1/(w*w) : 0;
        else obs.weight = obs.i_obs>0 ? 1/obs.i_obs : 0;
      total++;
      if (total==1) l_diag->dtheta0 = obs.dtheta;
      obs.weight *= l_exper->weight;
      data_write (&obs);
      if (obs.weight>0 && obs.weight>l_diag->w_mini)
		      l_diag->w_mini = obs.weight;
      }
    l_diag->dthetaf = dt;
    tst_abort((total==0),E_ZEROP,l_diag->fich_name);
    pop_err_msg();
     return (total);
     }

/* ------------------------------------------------------------------ */
/* ------------------------------------------------------------------ */
void get_real_data (P_(void))
{    FILE   *fich;
     int    i, nb, num;
     TYPE_OBS    obs;

     push_err_msg("get_real_data(xnd_rex1.c)");
    for (num=0; num < l_exper->n_diag; num++,l_diag++)
    {    l_diag->w_mini = MINFLOAT;
     		l_diag->fich_name[0] = 0;
	   if ( get_keys("DATA", NULL,
       "FILE",    KEYTYPE_CHAR, &(l_diag->fich_name), &l_diag->fich_name, 
       "SIZE",    KEYTYPE_INT,    &(nb),            0,
       "TEMP",    KEYTYPE_FLOAT,  &(l_diag->temp),    &l_exper->temp_orig,
        NULL ) == -1 )
   /* the following allows xnd_1.17 header to be read */
     fscanf (coord_fich,"%f%d %[^\n]",&l_diag->temp,&nb,l_diag->fich_name);
     fprintf (list_fich," DIAG : T = %.3f,   pts %4d  : '%s'\n",
		 l_diag->temp, nb, l_diag->fich_name);
     if ((disk_data&2) == 0)
     {  fich = tst_open (l_diag->fich_name,"r","data file");
	     switch (l_exper->dfich)
	    {  case 10: l_diag->n_points = step_fich(fich, 1, 0); break;
	       case 11: l_diag->n_points = step_fich(fich, 8, 0); break;
	       case 12: l_diag->n_points = step_fich(fich,10,0); break;
	       case 13: l_diag->n_points = step_fich(fich,10,-1); break;
	       case 14: l_diag->n_points = step_fich(fich,10, 1); break;
	       case 15: l_diag->n_points = step_fich(fich,8,-1); break;
	       case 16: l_diag->n_points = step_fich(fich,8, 1); break;
	       case 1 : l_diag->n_points = tab_fich(fich, 0, 0, 0, 0); break;
	       case 2 : l_diag->n_points = tab_fich(fich, 1, 0, 0, 0); break;
	       case 3 : l_diag->n_points = tab_fich(fich, 0, 0, 0, 1); break;
	       case 4 : l_diag->n_points = tab_fich(fich, 1, 0, 0, 1); break;
	       default: if (l_exper->dfich>=100 && l_exper->dfich<200)
   l_diag->n_points = tab_fich(fich, (l_exper->dfich/10)%10, l_exper->dfich%10, 0, 0);
	  		if (l_exper->dfich>=1000 && l_exper->dfich<2000)
   l_diag->n_points = tab_fich(fich, (l_exper->dfich/100)%10, (l_exper->dfich/10)%10, l_exper->dfich%10, 1);
		else tst_abort (1,"%s","Unknown file type");
	       }
	  fclose (fich);
	  tst_abort((l_diag->n_points==0),E_ZEROP,l_diag->fich_name);
	  verbose_printf (" %d data values get between %.3f and %.3f\n",
		  l_diag->n_points,l_diag->dtheta0,l_diag->dthetaf);
	  if ( nb && nb != l_diag->n_points)
	     fprintf (list_fich,"Warning, the number of values found is not the expected one\n");
	  l_diag->w_mini = 1 / sqrt (l_diag->w_mini);
	  write_chk();
	  }
     else
     {    l_diag->n_points = nb;
	  for (i=0;i<nb;i++) data_read(&obs);
	  tst_abort ((fabs(read_chk()-l_diag->temp)>EPS_CHK),"Verif data_fich");
	  }
     lect->tot_points += l_diag->n_points;
     if (l_diag->n_points > lect->max_points)
	lect->max_points = l_diag->n_points;
	 }
    pop_err_msg();
    }

/* ------------------------------------------------------------------ */
/* ------------------------------------------------------------------ */
