static char *cvs_id =" $Id: xnd_rpha.c,v 1.7 2005/03/10 14:10:08 berar Exp $ ";
/* XND_RPHA.C     this file read all data for phases except crystal */

#define USE_VAR
#define USE_KEYS
#define USE_SETS
#define USE_DIFDAT
#define USE_ATOM
#define USE_PENAL
#define USE_PHASE
#include "../xnd_def.h"
#include "xnd_rdh.h"

/* ------------------------------------------------------------------ */
static char   *txt_ech[ECH]     = {"Scale","Bo"};
static char   *txt_transit[TRANSIT]  = {"T_o","D_T","Exp"};
static char   *txt_qcell[3]     = {"Centr.","A","C"};
static char   *txt_dist[2]      = { "Dist","Int"};
static char   *txt_radial[4]    = { "Occ","R","s","m3"};
static char   *txt_tds[TDS]     = {"w_unc","tds_sp","tds_rd"};
static char   *txt_rdfcell[1]   = {"Rho"};
static char   *txt_rdfpeak[3]   = {"A", "R", "S"};
/* ------------------------------------------------------------------ */

static void check_dif (P_(char *)espece_lue)
#ifdef NO_PROTO
char *espece_lue;
#endif
{    char espece[11];
	char *p_esp;
	l_atom->xdif = l_atom->ndif = l_atom->mdif = l_atom->uxdif = l_atom->undif = NULL;
        l_atom->adif = NULL;
	if (lect->nature & LECT_NAT_RX)
	{   strcpy (espece,"0");
	    strcat (espece,espece_lue);
	    p_esp = espece+1;
	    while (isdigit(*p_esp)) p_esp++;
	    l_atom->xdif = get_dif(p_esp,1);
	    if (lect->nature & LECT_NAT_RXA) l_atom->adif = get_adif(p_esp);
	    if (l_phase->uncoherent & DIF_COMPTON)
	    {    p_esp--;
	        *p_esp='&';
		l_atom->uxdif = get_dif(p_esp,1);
		}
	    }
	if (lect->nature & LECT_NAT_N)
	{       strcpy (espece,"0");
	        strcat (espece,espece_lue);
		p_esp = espece+1;
		while (isalpha(*p_esp)) p_esp++;
		*p_esp=0;
		p_esp = isalpha(espece[1]) ? espece : espece+1;
		l_atom->ndif = get_dif(p_esp,1);
		if (lect->nature & LECT_NAT_NM)
	        espece[0]='-';
		p_esp = espece;
		l_atom->mdif = get_dif(p_esp,0);
	        if (l_atom->mdif== NULL)
		{   espece[0]='_';
		    p_esp = espece;
		    l_atom->mdif = get_dif(p_esp,0);
		    }
		if (l_phase->uncoherent & DIF_COMPTON)
	        {   espece[0]='$';
		    l_atom->undif = get_dif(p_esp,1);
		}
	    }	
	}

/* ------------------------------------------------------------------ */
void fget_radial (P_(void))
{  int i,j,n;
   int nd=0;
   if ( get_keys("NONCRYST", NULL,
	    "ATOM",  KEYTYPE_INT,  &l_phase->n_atom  , (int) 1,  
	    "DIST",  KEYTYPE_INT,  &l_phase->nb_dist , (int) 1,  
	    "UNCOH", KEYTYPE_INT,  &l_phase->uncoherent, (int) 0,  
	     NULL ) == -1 )
   {  fscanf (coord_fich,"%d%d%d", &l_phase->n_atom, &l_phase->nb_dist, &l_phase->uncoherent);
		}
   if (l_phase->n_atom == 1 )
   {   nd=l_phase->nb_dist;
       verbose_printf(" 1 atom, %d points in radial distrib\n",nd);
       }
   else
   {   if (l_phase->nb_dist > 0  )
      {   nd=l_phase->nb_dist;
          verbose_printf(" %d atoms, distribution is common to all atoms, nb_dist=%d>0\n",l_phase->n_atom, nd);
          }
      else 
      {   nd=-l_phase->nb_dist;
          verbose_printf(" %d atoms, distribution is must contains %d for each atom : %d values\n",
                   l_phase->n_atom, nd, l_phase->n_atom*nd);
          }
      }    
    fprintf (list_fich," uncoherent code  %d implies : %s\n", l_phase->uncoherent,
            l_phase->uncoherent & DIF_COMPTON ? " compton":"");

	tst_abort ((l_phase->n_atom<=0)," nb_atom <= 0");
	tst_abort ((l_phase->uncoherent>1)," uncoherent > 1");
   l_phase->atom = fget_atom (l_phase->n_atom, -1);
	tst_abort ((nd<2)," abs(nb_dist) <  2");
   if (l_phase->nb_dist > 0  )
      l_phase->radial = fget_var(nd, 1, VAR_FLOAT, T_RADIAL, NULL, NULL, NULL, 0, 0);
   else 
      l_phase->radial = fget_var(nd*l_phase->n_atom, 1, VAR_FLOAT, T_RADIAL, NULL, NULL, NULL, 0, 0);
    if (l_phase->uncoherent)
    {   l_phase->tds=fget_var ( 1, 0, VAR_STD, "DIFFUSE",
	       ( void * ) txt_tds, NULL, NULL, 0, 0);
        }    
	}
/* ------------------------------------------------------------------ */
void fget_rdf_peaks (P_(void))
{   int i,j,n;
    float rlim =5;
    float rstep=0.1;
    float rmin= 0;
    
   l_phase->bond=(float *) malloc(4*sizeof(float));
   tst_abort(( get_keys("RDFPEAKS", NULL,
	    "ATOMS",  KEYTYPE_INT,  &l_phase->n_atom  , (int) 1,  
	    "PEAKS", KEYTYPE_INT,   &l_phase->nb_dist , (int) 0,  
	    "PRINT", KEYTYPE_INT,   &l_phase->nb_angl , (int) 0,  
	    "RSTEP", KEYTYPE_FLOAT, &l_phase->bond[0] , (float*) &rstep,  
	    "RLIM",  KEYTYPE_FLOAT, &l_phase->bond[1] , (float*) &rlim,  
	    "RMIN",  KEYTYPE_FLOAT, &l_phase->bond[2] , (float*) &rmin,  
	    "UNCOH", KEYTYPE_INT,  &l_phase->uncoherent, (int) 0,  
	     NULL ) ==-1 ), "key RDFPEAKS required");
    if ( l_phase->uncoherent && l_phase->uncoherent != DIF_COMPTON )
         fprintf (list_fich," uncoherent code %d is not %d (=compton) : no effect\n",
            l_phase->uncoherent, DIF_COMPTON);

   fprintf(list_fich,"\n");
   l_phase->atom = fget_atom (l_phase->n_atom, -1);
   fprintf(list_fich,"\n");
	l_phase->radial = fget_var(3*l_phase->nb_dist, 3, VAR_ORIEN,
             T_RDFPEAK, (void **) txt_rdfpeak, NULL, NULL, 0, 0);
	}
/* ------------------------------------------------------------------ */

static int fget_quasi_par (P_(int) is_quasi)
{   int nb_hkl;
    l_phase->symgrp = NULL;
    l_phase->n_atom = l_phase->nb_par = l_phase->nb_bloc =
    l_phase->n_orien = 0;
    fscanf (coord_fich,"%d%d", &l_phase->n_prof, &nb_hkl);
    fprintf (list_fich,"  %d profile coef %d lines\n\n",
       l_phase->n_prof, nb_hkl);
    tst_abort((l_phase->n_prof>1), "too much coefs for such phase (>1)");
    tst_abort((nb_hkl<=0), "lines must be defined (>0)");
    if (is_quasi)
    {  l_phase->cell=fget_var(3, 0, VAR_STD, T_CELL, (void *)txt_qcell, NULL, NULL, 0, 0);
       fprintf(list_fich,"\n");
       }
    l_phase->sets = current_sets = sets_make( NULL, 1, nb_hkl);
    l_phase->nb_sets = 1;
    fget_phase_prof();
	 if (is_quasi)
    {  l_phase->hkl_size = 3;
	    current_sets->intensity=fget_var(nb_hkl, 1, VAR_HKL, T_HKL, NULL, NULL, NULL, 0, 0);
		 }
    else
    current_sets->intensity=fget_var(2*nb_hkl, 2, VAR_STD, T_HKL, (void *)txt_dist, NULL, NULL, 0, 0);
    return 0;
    }

/* ------------------------------------------------------------------ */
/* ------------------------------------------------------------------ */

void read_phase (P_(int) phase_num)

#ifdef NO_PROTO
int phase_num;
#endif
{
#define CAS_HKL 9
	char   *txt_nature[CAS_HKL];
	int    i, j, nb_hkl;

	push_err_msg("read_phase(xnd_rpha.c)");
	txt_nature[CAS_HKL-9] = "amorphe(reserved)";
	txt_nature[CAS_HKL-8] = "magnet+modul";
	txt_nature[CAS_HKL-7] = "modulation";
	txt_nature[CAS_HKL-6] = "magnet";
	txt_nature[CAS_HKL-5] = "quasicubique";
	txt_nature[CAS_HKL-4] = "parasite";
	txt_nature[CAS_HKL-3] = "radial";
	txt_nature[CAS_HKL-2] = "hkl_generes";
	txt_nature[CAS_HKL-1] = "hkl_lus";
   memset(l_phase, 0, sizeof(TYPE_PHASE));
	l_phase->temp_orig = KEY_PHASE_ORIG;
	l_phase->remark = read_remark(NULL);
   l_phase->num = phase_num;
   temp_phase=0;  /* to avoid SIGSEGV in atom-site with order > 2*/
   temp = &temp_phase;
   if ( get_keys("PHASE", NULL,
       "TITLE",    KEYTYPE_STRING,  l_phase->nom, "",
       "NATURE",   KEYTYPE_INT,    &(l_phase->nature), KEY_PHASE_NATURE,
       "TRANSIT",  KEYTYPE_INT,    &(j), KEY_PHASE_TRANSIT,
       "ORIG",     KEYTYPE_FLOAT,  &(l_phase->temp_orig), &l_phase->temp_orig,
        NULL ) == -1)
	{	fscanf (coord_fich, "%d%d%f", &l_phase->nature, &j,
			&l_phase->temp_orig);
	   purge_cr();
	   fscanf (coord_fich, " %[^@\n]", l_phase->nom);
      }
	i=l_phase->nature+CAS_HKL-2;
	if (i>=CAS_HKL) i=CAS_HKL-1;
	fprintf(list_fich,"\n\n PHASE #%d : %d (%s), %d T transitions, origine du developpement :%.3f\n '%s'\n",
		 phase_num, l_phase->nature,txt_nature[i], j,
                 l_phase->temp_orig, l_phase->nom);
	if (bavard) printf(" PHASE : '%s'\n",l_phase->nom);
   if (l_phase->nature > 0 )
        {     nb_hkl = l_phase->nature;
              l_phase->nature = 1;
              }
        else nb_hkl = 0;
	l_phase->n_var = n_var;
	l_phase->ech=fget_var(ECH,0, VAR_STD,T_ECHELLE,(void *) txt_ech, NULL, NULL, VAR_MODE_GT0, 0);
	l_phase->transit=fget_var(j*TRANSIT,TRANSIT, VAR_STD,
			T_TRANSIT,(void *)txt_transit, NULL, NULL, 0, 0);
        fprintf(list_fich,"\n");

	switch (l_phase->nature)
	{   case PHASE_RADIAL   : fget_radial ();  break;
	    case PHASE_PARASITE : fget_quasi_par(0);  break;
	    case PHASE_QUASI    : fget_quasi_par(1);  break;
		 case PHASE_RDFPEAK  : fget_rdf_peaks ();  break;
	    default             : fget_crystal (nb_hkl);
	    }
	l_phase->n_var = n_var - l_phase->n_var;
	pop_err_msg();
	}

/* ------------------------------------------------------------------ */




