 /* XND_RSYM.C    lecture des symetries */
static char *cvs_id =" $Id: xnd_rsym.c,v 1.3 2004/07/30 08:04:40 berar Exp $ ";

#define USE_VAR
#define USE_SYM
#define USE_MODUL
#define USE_PHASE
#include "../xnd_def.h"
#include "xnd_rdh.h"
#include <string.h>
/* ------------------------------------------------------------------ */
static TYPE_SYMGRP * swap_sym PROTO((void));
static void mul_sym PROTO((int dim, float * s1, float *s2, float *dest));
static int  ident_sym PROTO((int dim, float * s));
static int  order_sym PROTO((int dim, float * s)); 
/* ------------------------------------------------------------------ */
void num_deno PROTO((float fract, int *num, int *deno))
{  *num =0; 
   *deno = 1;
	if (fabs(fract)>EPSILON)
	{  if (fract>0) *num = floor (fract * 48 + 0.5);
	   else *num = ceil (fract* 48 - 0.5);
		*deno = 48;
		while ((*num%2==0) && (*deno%2==0)) { *num/=2; *deno/=2; };
		while ((*num%3==0) && (*deno%3==0)) { *num/=3; *deno/=3; };
		}
   }
/* ------------------------------------------------------------------ */
void fprint_xyz_pos (P_(FILE *) file, P_(float *) l_coef, P_(char) end_char)
#ifdef NO_PROTO
FILE *file;
float *l_coef;
char end_char;
#endif
{   int   i,j;
    float val;
    float *coef;
    int   num,deno,first;
    int    dim = 3;
    int    dim2;

    push_err_msg("fprint_xyz_pos(xnd_rsym.c)");
    if (current_symgrp->systeme =='*') dim =current_symgrp->holoedre;
    dim2 = 1 + dim;

    fprintf(file,"  ");
    for (j=0,coef=l_coef; j<dim; j++,coef++)
    {   first =1;
	for (i=0; i<dim2; i++)
	{  if (fabs(coef[dim*i])>EPSILON)
	   {  num_deno(coef[dim*i] , &num, &deno);
		   if (i==dim) fprintf (file,"%+d",num);
		   else if (num==1) fprintf (file,"%s%c",first?"":"+",'X'+i);
		   else if (num==-1) fprintf (file,"-%c",'X'+i);
		   else fprintf (file,"%d%c",num,'X'+i);
		   if (deno!=1) fprintf (file,"/%d",deno);
		   first = 0;
		   }
	   } 
	if (j!=dim-1) fprintf (file,", ");
	}
   fprintf (file,"%c",end_char);
   pop_err_msg();
   }
/* ------------------------------------------------------------------ */
void print_sym(P_(TYPE_SYMGRP *) symgrp, P_(int) cas)
#ifdef NO_PROTO
TYPE_SYMGRP *symgrp;
int cas;
#endif
{   int i;
    float *l_coef;
    char *txt;

    push_err_msg("print_sym(xnd_rsym.c)");
    if (symgrp->systeme != '*')
    {     switch (symgrp->systeme)
          {    case 'C' : txt = "Cubique"; break;
               case 'Q' : txt = "Quadratique"; break;
               case 'H' : txt = "Hexagonal"; break;
               case 'R' : txt = "Rhomboedrique/Hexagonal"; break;
               case 'T' : txt = "Trigonal"; break;
               case 'O' : txt = "Orthorhombique"; break;
               case 'M' : txt = "MonocliniqueB"; break;
               case 'N' : txt = "MonocliniqueC"; break;
               case 'L' : txt = "MonocliniqueA"; break;
               case 'A' : txt = "Anortic=triclinique"; break;
                };
	if (cas) fprintf(list_fich," Symetry group '%s'", symgrp->nom);
	fprintf(list_fich, 
            "  %s system %c (%s) holoedric %d, %d %s, %d operations \n",
		symgrp->comment, symgrp->systeme,txt,symgrp->holoedre, 
                symgrp->centro, symgrp->centro==1?"(-x,-y,-z) * ":"NotCentered",
                symgrp->nops);
        }
     else
     {
        if (cas) fprintf(list_fich,
         " Complement de symetrie pour structure modulee '%s'", symgrp->nom);
	fprintf(list_fich, 
            "  %s %c dimension %d, (%d) %d operations \n",
		symgrp->comment, symgrp->systeme, 
                symgrp->holoedre, symgrp->centro, symgrp->nops);
           }
        
        current_symgrp = symgrp;
	for (i=0,l_coef=symgrp->coef; i<symgrp->nops; i++,l_coef+=symgrp->size)
        {   fprintf (list_fich," #%2d ", i);
	    fprint_xyz_pos (list_fich, l_coef, '\n');
	    }
        fprintf(list_fich,"\n");
    pop_err_msg();
    }

/* ------------------------------------------------------------------ */
void new_sym(P_(TYPE_SYMGRP *) symgrp)
#ifdef NO_PROTO
TYPE_SYMGRP *symgrp;
#endif
{   int i;
    char c;
    float *l_coef;

   push_err_msg("new_sym(xnd_rsym.c)");
   fprintf(new_fich," %s #%s %c %d %d %d\n",
		symgrp->nom, symgrp->comment, symgrp->systeme,
                symgrp->holoedre, symgrp->centro,symgrp->nops);
    current_symgrp = symgrp;
    for (i=0,l_coef=symgrp->coef;i<symgrp->nops;i++,l_coef+=symgrp->size)
	{   c = (i%4)!=3 ? ';' : '\n';
	    fprint_xyz_pos ( new_fich, l_coef, c);
		}
    fprintf(new_fich,"\n");
    pop_err_msg();
    }

/* ------------------------------------------------------------------ */
int analyse_xyz_pos(P_(char *) ligne, P_(float *) l_coef, P_(TYPE_SYMGRP *)l_sym, P_(int) dim )
#ifdef NO_PROTO
char *ligne;
float *l_coef;
TYPE_SYMGRP *l_sym;
int dim;
#endif
{   float  num,deno;
    int    div,dig,sig;
    int    j, range;
    char   *ligne_p,car;
    int    dim2;
    int    valid =0;
    int    err = 0;
    push_err_msg("analyse_xyz_pos(xnd_rsym.c)");
    dim2 = dim*dim;
    if (strlen(ligne)>=NAME_LG) ligne[NAME_LG-1]=0;
	strup (ligne);
	ligne_p=ligne;
	num = deno = 0;
	j = dig = div = 0;
	sig = 1;
	range = -1;
	while ((car= *ligne_p)!=0)
	{   ligne_p++;
		if (isdigit(car))
		{   dig++;
			if (div==0) num = num*10+car-'0';
			else deno = deno*10+car-'0';
			valid++;
			}
	     else if (car=='/')
	     {   if (num==0) num = 1;
			 div=1;
			 }
	     else switch (car)
		 {   case 'X' :
			 case 'Y' :
			 case 'Z' : range = j + dim *(car-'X');
				    if (num==0) num = 1;
			            valid++;
				     break;
			 case ',' :
			 case '-' :
			 case '+' : if (div!=0)  num /= deno;
					if (range == -1) range = j + dim2;
					if (num!=0) l_coef [range] = sig*num;
					range = -1;
					num=deno=0; div=0;
					sig = car=='-'?-1:1;
					if (car==',') j++;
					break;
			 default  : if (car !=' ' && car != '\r')
		{  if (l_sym!=NULL) fprintf(list_fich," Group '%s'\n",l_sym->nom);
		   fprintf(list_fich,
		    " unable to understand '%c' (%02x) in '%s'\n", 
		        car, car, ligne);
                    tst_abort( (err++>5), "reading symmetry data");			
		    };
			 };
		};
	if (div!=0)  num /= deno;
	if (range == -1) range = j + dim2;
	if (num!=0) l_coef [range] = sig*num;
	pop_err_msg();
	if (valid < dim) return 0;
	return 1;
	}
/* ------------------------------------------------------------------ */
TYPE_SYMGRP *read_sym (P_(FILE *) file)
#ifdef NO_PROTO
FILE *file;
#endif
{  char  name[31], comment[NAME_LG], line[121], copie[60];
   int   i,j,s;
   char  systeme,bravais,*pos,*p;
   int   holo,centro,nops,ngen;
	int   dim = 3;
   int   size = 12;
   float  *l_coef;
   TYPE_SYMGRP *l_sym = NULL;

   do
	{  line[0]=0;
	   fgets (line, sizeof(line)-1, file);  /* ignore comment lines... */
      if (feof(file)) return NULL;
		p = line;
		while (*p==' ') p++;
		} while (*p=='#' || *p=='\n' || *p=='\r' || *p==0);
	if ((pos=strchr(line,'#'))) *pos=0; 
   sscanf(p,"%s", name);
   push_err_msg("read_sym (xnd_rsym.c)");
   push_err_msg(name);
   fscanf(file," %[CQHTROMNLA*]", copie);
   systeme = copie[0];
   purge_cr();
   i = fscanf(file," %d%d%d%*[\r]", &holo, &centro, &nops);
   if (feof(file)) { pop_err_msg(); return NULL; }
   tst_abort(( i<3  || nops > 1000 || nops==0), "invalid data in symgrp header '%s'", name);
   if (strlen(name)>=SYM_ID) line[SYM_ID-1]=0;
   strup(name);
   bravais = name[0];
   if (bravais == '*')
   if ( systeme == '*') { dim = holo; size = holo*(holo+1);}
    else tst_abort (1,"Unvalid 4-dim symmetry complement");
   if (pos) strncpy(comment, pos+1, NAME_LG-1); else comment[0]=0;
   if (nops > 0)
	{  s=sizeof(TYPE_SYMGRP)+(size*nops-1)*sizeof(float);
	   l_sym = (TYPE_SYMGRP *)tst_alloc(1, s, "symgrp");
      memset(l_sym, 0, s);
      n_sym++;
		strcpy(l_sym->nom, name);
      strncpy(l_sym->comment, comment, NAME_LG-1);
       l_sym->systeme=systeme;
       l_sym->holoedre=holo;
       l_sym->bravais=bravais;
       l_sym->centro=centro;
       l_sym->nops=nops;
       l_sym->size=size;
       for (i=0,l_coef=l_sym->coef;i<nops;i++,l_coef+=size)
       {   fscanf(file," %[^;\n]%*[;\n]",line);
	        while(!analyse_xyz_pos (line, l_coef, l_sym, dim));
	       }
		 }
	else
	{  float * g_coef, *e, *d, *f;
	   int k, n, * g_ord;
	   ngen = -nops;
		fprintf(list_fich, " reading group structure from %d generators\n", ngen);
		g_coef = (float *)tst_alloc(1, size*ngen*sizeof(float), "symgrp");
      memset(g_coef, 0, size*ngen*sizeof(float));
		g_ord = (int *)tst_alloc(1, size*ngen*sizeof(int), "symgrp");
      memset(g_ord, 0, size*ngen*sizeof(int));
		nops = 1;
      for (i=0,l_coef=g_coef;i<ngen;i++,l_coef+=size)
      {  fscanf(file," %[^;\n]%*[;\n]",line);
	      while(!analyse_xyz_pos (line, l_coef, l_sym, dim));
	      nops *= g_ord[i] = order_sym(dim, l_coef);
		   }
	   s=sizeof(TYPE_SYMGRP)+(size*nops-1)*sizeof(float);
		l_sym = (TYPE_SYMGRP *) tst_alloc(1, s, "symgrp");
      memset(l_sym, 0, s);
      n_sym++;
      strcpy(l_sym->nom, name);
      strncpy(l_sym->comment, comment, NAME_LG-1);
      l_sym->systeme=systeme;
      l_sym->holoedre=holo;
      l_sym->bravais=bravais;
      l_sym->centro=centro;
      l_sym->nops=nops;
      l_sym->size=size;
		l_coef = l_sym->coef;
		for (i=0; i<dim; i++) l_coef[i+dim*i]=1;
		n = 1;
		s = dim*(dim+1);
		d = l_coef +s;  e = l_coef;
		for (i=0, f = g_coef; i <ngen; i++, f+=s) 
		{  e = l_coef;
		   for (j=1; j < g_ord[i]; j++) 
		   {  for (k=0; k <n; k++, d+=s, e+=s) mul_sym(dim, e, f, d);
		      }
			n = ( d - l_coef ) / s;
			}
	   free(g_coef);
		free(g_ord);
		}	 	 
   pop_err_msg();
   pop_err_msg();
   return(l_sym);
   }
/* ------------------------------------------------------------------ */
TYPE_SYMGRP *get_sym (P_(char *) modele)
#ifdef NO_PROTO
char *modele;
#endif
{   TYPE_SYMGRP *l_sym;
    FILE   *sym_fich;
 	 char   filename[200];
    int i;

    push_err_msg("get_sym(xnd_rsym.c)");
    strup (modele);
    if (strcmp(modele,"SWAP_COMPO")== 0) return swap_sym();
    for (i=0;i<n_sym;i++)
	 if (strcmp(lect->symgrp[i]->nom,modele)==0) 
	 {   pop_err_msg();
	     return(lect->symgrp[i]);
	     }
    sym_fich = fopen (SYM_FILE,"r");
	 if ( ! sym_fich )
	 {  sym_fich = tst_open (lect->sym_name,"r","Open sym file");
	    strcpy(filename,lect->sym_name);
	    } else strcpy(filename,SYM_FILE);
    do
    {   l_sym=read_sym(sym_fich);
	 if (l_sym && strcmp(l_sym->nom,modele)==0)
	 {   if (lect->prt_sym & 2) print_sym (l_sym, 0);
	     switch (l_sym->systeme)
	     {   case 'C': case 'Q': case 'H': case 'R': case 'T':
		      case 'O': case 'M': case 'N': case 'A': break;
		      default : if (lect->prt_sym<=1) print_sym (l_sym, 0);
			   termine (10,"Invalid Lattice");
		     } 
	     fclose (sym_fich);
	     lect->symgrp[n_sym-1]=l_sym;
             pop_err_msg();
	     return(l_sym);
	     } 
	 if (l_sym) free(l_sym);
	 n_sym--;
	 }
    while (!feof(sym_fich));
    tst_abort (1,"No SYM : %s found in %s",modele,filename);
    pop_err_msg();
    return(NULL);
    }
/* ------------------------------------------------------------------ */
/* following are used by get_sym to generated the group               */
static void mul_sym (P_(int) dim, P_(float *) s1, P_(float *) s2, P_(float *) dest)
#ifdef NO_PROTO
int dim;
float *  s1, s2, dest;
#endif
{  int i, j, k;
   for (i=0; i<dim; i++)
	{  for  (j=0; j<dim; j++)
	   {  dest[i+dim*j] = 0;
		   for (k=0; k<dim; k++) dest[i+dim*j] += s1[i+k*dim]*s2[k+dim*j];
		   }
	   dest[i+dim*dim] = s1[i+dim*dim];
	   for (k=0; k<dim; k++) dest[i+dim*dim] += s1[i+k*dim]*s2[k+dim*dim];
	   dest[i+dim*dim] -= floor(dest[i+dim*dim]);
		}
   }
/* ------------------------------------------------------------------ */
#define ESP_SYM 0.001
static int  ident_sym(P_(int) dim, P_(float *) s) 
#ifdef NO_PROTO
int dim;
float *  s;
#endif
{  int i, j;
   for (i=0; i<dim; i++)
	{  for  (j=0; j<dim; j++)
	   {  if (i==j) { if (fabs(s[i+dim*j]-1.0) > ESP_SYM ) return 0; }
		   if (i!=j) { if (fabs(s[i+dim*j]) > ESP_SYM ) return 0; }
		   }
	   if (fabs(s[i+dim*dim]) > ESP_SYM ) return 0; 
		}
   return 1;
	}
/* ------------------------------------------------------------------ */
static int  order_sym(P_(int) dim, P_(float *) s) 
#ifdef NO_PROTO
int dim;
float *  s;
#endif
{  float i[12], d[12], e[12];
	int t, g_ord = 1;
	t = dim *(dim+1)*sizeof(float);
   memcpy(e, s, t);
	do 
	{  g_ord ++;
	   mul_sym( dim, e, s, d);
      memcpy(e, d, t);
      } while ( ident_sym( dim, d) == 0 );
   return g_ord;
	}
/* ------------------------------------------------------------------ */
/* specific to composite, constructs 2nd layer group swaping z and t  */
static TYPE_SYMGRP *swap_sym (P_(void))
{   TYPE_SYMGRP *l_sym, *l_sym4, *m_sym, *m_sym4;
    float *d, *d4, *n, *n4;
    int i, s;
    push_err_msg("swap_sym(xnd_rsym.c)");
    fprintf(list_fich," generating symmetry group for 2nd layer swaping z and t\n");
    tst_abort ((current_modul==NULL || current_modul->compo_atom==0), "not in composite modulated phase");
    l_sym = l_phase->symgrp;
    l_sym4 = current_modul->symgrp;
    s = sizeof(TYPE_SYMGRP)+(l_sym->size*l_sym->nops-1)*sizeof(float);
    current_modul->compo_sym = m_sym = (TYPE_SYMGRP *)tst_alloc(1, s, "symgrp");
    memcpy(m_sym, l_sym, s);
    strcpy(m_sym->nom, "SWAP_COMPO");
    sprintf(m_sym->comment,"#generated from %s and %s\n", l_sym->nom, l_sym4->nom);
    s = sizeof(TYPE_SYMGRP)+(l_sym4->size*l_sym4->nops-1)*sizeof(float);
    current_modul->compo_sym4 = m_sym4 = (TYPE_SYMGRP *)tst_alloc(1, s, "symgrp");
    memcpy(m_sym4, l_sym4, s);
    strcpy(m_sym4->nom, "SWAP_COMPO");
    strcpy(m_sym4->comment, m_sym->comment);
    d = l_sym->coef;
    n = m_sym->coef;
    d4 = l_sym4->coef;
    n4 = m_sym4->coef;
    s = l_sym->size;
    for (i=0; i<l_sym->nops; i++, n+=s, d+=s, n4+=2, d4+=2)
    {  n[8]  = d4[0];
       n[11] = d4[1];
       n4[0] = d[8];
       n4[1] = d[11];
       }
    if (lect->prt_sym & 2)
    {  print_sym (m_sym, 1);
       print_sym (m_sym4, 1);
       }
    pop_err_msg();
    pop_err_msg();   /* direct call by get sym */
	 return m_sym;
    }
/* ------------------------------------------------------------------ */



