/* $Id: xnd_def.h,v 1.4 2004/07/30 08:05:29 berar Exp $ */
/*  xnd_def.h    definitions generales */
/*  les principales dependances du site */

/* if you prefer double instead of float in derivatives ...*/
/*  #define DOUBLEFLOAT 1 */
/* needed for float in the Bragg structure on HPUX and others ??? */
/* on 64 bits machine, it may be 8 ??? */
#define FLOAT_BOUNDARY  4

#ifdef __BORLANDC__
/* les compilateurs borland sur PC  Borlandc */
#ifndef __WIN32__
#error MS-DOS and its segmented memory is no more supported
/* si WIN32 le mode console est requis */
#endif   /*w32 */
#ifndef __CONSOLE__
#error Console application is required with Win32
#endif   /*console */
#define  OS_CHECK_ABORT
#define  CLOCK_UNIT 0.001
#define  MATHERR
#define  END_PATH_STR   "\\"

#else
#ifdef VAXC                    /* argument du compilation */
/* compilation sur VAX sous VMS */
#define  MAX_ALLOC 2000000L    /* 2Mo dans le meme tableau */
#define  END_PATH_STR   "]"
#define  unlink    delete      /* le compilateur n'utilise pas le nom std */

#else
#ifdef __SC__                  /* Symantec C pour Mac  */
#define MAC_OS
#define  MAX_ALLOC 512000L      /* 512kO  */
#endif 
#ifdef __POWERPC__             /* CodeWarrior C pour Mac powerpc  */
#define MAC_OS
#define  MAX_ALLOC 512000L      /* 512kO  */
#endif 
#ifdef THINK_C                /* compilateur ThinkC sur Mac */
#define MAC_OS
#define  MAX_ALLOC 256000L      /* 256kO  */
#define  CONSTANTE_PURE         /* pas d operations dans les constantes d initialisation */
#endif

#if defined (MAC_OS) && (MAC_OS!=darwin)
#define  OS_CHECK_ABORT
#define  END_PATH_STR   ":"
#define CLOCK_UNIT 0.01
#include <stdlib.h>

#else
#ifdef   __CYGWIN__
/*  gcc cygnus compiler used in dos windows */
#define  END_PATH_STR   "/"
#define  NAME_LG        180
#define CLOCK_UNIT 0.01

#else
/* assuming we are unix now */
#define UNIX_OS
#define  END_PATH_STR   "/"
#define  NAME_LG        180

#ifndef __STDC__
#define  NO_PROTO          /* ANSI prototypes not known in K.R. C */
#endif

#ifndef CLOCK_UNIT
#define CLOCK_UNIT 0.000001
#endif


#endif
#endif
#endif
#endif
/* end of dependencies configuration related to operating system */

/* allow KR or ANSI compilation */
#ifdef   NO_PROTO
#define  PROTO(a)  ()
#define  P_(a)
#else
#define  PROTO(a)  a
#define  P_(a)     a
/* includes also stdlib wich is not know in KR */
#include <stdlib.h>
#endif

#include <stdio.h>
#include <math.h>

#ifdef MSDOS
#include <values.h>
#endif

#ifdef UNIX_OS
#ifndef MAC_OS
#include <values.h>
#endif
#endif

/* some test have been performed using double without real improvements */
#ifdef  DOUBLEFLOAT
#define FLOAT  double
#else
#define FLOAT  float
#endif

#ifndef MAX_ALLOC           /* en augmentant cette valeur la gestion */
#define MAX_ALLOC 6400000L  /* des gros fichiers passe au syst de pagination */
#endif
#ifndef NAME_LG
#define NAME_LG      80	    /* string slength */
#endif
#define  ERROR   "\n XND_ERROR"


#define  SYM_ID       20	/* sym grp name */
#define  MAX_LAMBDA   50
#define  MAX_ASYM     6	/* higher asym expansion */
#define  MAX_ORIEN     5        /* higher expansion in orien */

#define  MAX_DIF     200  	/* used in lecture phase */
#define  MAX_SYM     200
#define  MAX_COD    2000
#define  CHK_VAL   (-999.99)

      /* chemin d'acces au fichier *.d */
#define  PROG_PATH ""            /* automatique par argv[0] */

#define  PRG_ID    "xnd"
#define  DOC_ID    "xnd_doc.d"
#define  DIF_FILE  "xnd_dif.d"
#define  SYM_FILE  "xnd_sym.d"

#define EXPER_RX       1
#define EXPER_N        2
#define EXPER_ANO      4
#define EXPER_MAG      8
#define EXPER_RXA (EXPER_RX | EXPER_ANO)
#define EXPER_NM  (EXPER_N  | EXPER_MAG)
#define EXPER_ENER_RESOL     32
#define EXPER_SINGLE_CRYSTAL 64

#define PHASE_GENERE    0
#define PHASE_HKL_LU    1
#define PHASE_RADIAL   -1
#define PHASE_PARASITE -2
#define PHASE_QUASI    -3
#define PHASE_MAGNET   -4
#define PHASE_MODUL    -5
#define PHASE_MAGMOD   -6
#define PHASE_RDFPEAK  -7


#define DIF_COMPTON     1
#define DIF_TDS_HKL     2
#define DIF_TDS_000     4

#define PLG_NHEADER     2
#define PLG_ADDEND      4
#define PLG_ADDSEMI     8
#define PLG_QSTEP      16

/* drapeau de nature des atomes ou masque */
#define B_ANISO   1
#define MAGNET    2
#define MODUL     (4+8+16)
#define B_ANHARM3   32
#define B_ANHARM4   64
#define B_ANHARM5  128
#define B_ANHARM6  256
#define B_ANHARM  (B_ANHARM3+B_ANHARM4+B_ANHARM5+B_ANHARM6)
#define F_ROTAT    512
#define NATURE_MAX (B_ANHARM+B_ANISO+MAGNET+F_ROTAT)

#define  EPSILON_ANOMAL 0.0002
#define  CIF_BOND_SQUARE  7.0

 /* this to create or declare the variable as extern  */
#ifndef EXTERN
#define EXTERN    extern
#define EXTERN_NOT_SPACE
#endif

/* dimension for */
#define  INSTRU   4
#define  ASYM     3
#define  ASCNV    2
#define  LAMBDA   4
/*#define  REGLAGE  7*/
#define  BACK     1
#define  ORIEN    3
#define  ECH      2
#define  TRANSIT  3
#define  CELL     7
#define  PROF     6
#define  PASYM   2
#define  BCOOR    6
#define  VECTOR   3
#define  AMODUL   8
#define  DIF      2
#define  TDS      3   /* 2 and one spare */
/* selon les divers types d'atomes possibles */
#define  COORD_0    5
#define  COORD_ANIS 5
#define  COORD_MAGN 3
#define  COORD_ANHARM3 10
#define  COORD_ANHARM4 15
#define  COORD_ANHARM5 21
#define  COORD_ANHARM6 28
#define  COORD_MAX  (COORD_0+COORD_ANIS+COORD_MAGN+1)
#define  COORD_DIM  (1+COORD_MAX)
/* code interne des variables a affiner */
#define NUMER_X   0
#define NUMER_B   5
#define NUMER_K   (NUMER_B+COORD_ANIS+1)
#define NUMER_A   (NUMER_K+COORD_MAGN)

#define PROF_ANG   4
#define ORIEN_ANG  1
#define ORIEN_PROF (5+MAX_ASYM)
#define  DISTRI   2

typedef  short int sint;

#include "xnd_t_dep.h"    /* type dependence */
/*                 #include "xnd_typ.h"      */
#include "xnd_vah.h"
#include "xnd_fun.h"
#include "xnd_msg.h"

/* conservative values, if not defined it should works */

#ifndef  MAXFLOAT
#define  MAXFLOAT ((float)1.7E+38)
#endif
#ifndef  MINFLOAT
#define  MINFLOAT ((float)8.43E-37)
#endif
#ifndef  LN_MINFLOAT
#define  LN_MINFLOAT ((float)-83.06)
#endif
#ifndef  LN_MAXFLOAT
#define  LN_MAXFLOAT  ((float)88.03)	
#endif
#ifndef  FSIGNIF
#define  FSIGNIF 22
#endif
#ifndef  DSIGNIF
#define  DSIGNIF 50
#endif

#define  EPSILON  1.0E-25	/* in some tests */

#ifndef RAND_MAX
#define RAND_MAX 0xFFFFl
#endif

/* values for math constants .... to the end of the file */
/* Constants rounded for 21 decimals. */
#ifndef M_E
#define M_E		2.71828182845904523536
#endif
#ifndef M_LOG2E
#define M_LOG2E		1.44269504088896340736
#endif
#ifndef M_LOG10E
#define M_LOG10E	0.434294481903251827651
#endif
#ifndef M_LN2
#define M_LN2		0.693147180559945309417
#endif
#ifndef M_LN10
#define M_LN10		2.30258509299404568402
#endif
#ifndef M_PI
#define M_PI	 	3.14159265358979323846
#endif
#ifndef M_2PI
#define M_2PI	 	6.28318520717958647692
#endif
#ifndef M_PI_2
#define M_PI_2		1.57079632679489661923
#endif
#ifndef M_PI_4
#define M_PI_4		0.785398163397448309116
#endif
#ifndef M_1_PI
#define M_1_PI		0.318309886183790671538
#endif
#ifndef M_2_PI
#define M_2_PI		0.636619772367581343076
#endif
#ifndef M_1_SQRTPI
#define M_1_SQRTPI	0.564189583547756286948
#endif
#ifndef M_2_SQRTPI
#define M_2_SQRTPI	1.12837916709551257390
#endif
#ifndef M_SQRT2
#define M_SQRT2		1.41421356237309504880
#endif
#ifndef M_SQRT_2
#define M_SQRT_2	0.707106781186547524401
#endif

/* -------------------------------------------------------- */

#define  RAD            ( M_PI / 180.0 )
#define  M_GOLD         1.618033989

#define M_2LN2		(2*M_LN2)
#define M_4LN2		(4*M_LN2)
#define M_SQRT4LN2	 sqrt(4*M_LN2)
/* -------------------------------------------------------- */
/*    this allow some local overload .... */
#ifdef XND_SITE
#include XND_SITE
#endif
/* -------------------------------------------------------- */


